/**
 * @file  AEChannelArray.h
 * @brief Schnittstelle fuer die Klasse CAEChannelArray.
 */
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AE3CHANNELARRAY_H__E3C45889_4BC1_4E74_9A5C_284BD5DD180D__INCLUDED_)
#define AFX_AE3CHANNELARRAY_H__E3C45889_4BC1_4E74_9A5C_284BD5DD180D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Kanal - Klasse einbinden
#include "../Shared/Channel/AEChannel.h"

// Die oberste Klasse ist fuer Logfunktionen der DLL-Verwaltung reserviert!!!
#define MAX_CHANNEL	                401 // Maximalanzahl zu verwaltender Kanalklassen
#define LOG_CHANNEL_ID              (MAX_CHANNEL-1)
#define ACTIVE_CHANNEL_LOWER_BOUND  251 // Untere Grenze der Aktiven Kanalklassen (ist auch maximale Anzahl der festen Kanaele)
#define ACTIVE_CHANNEL_UPPER_BOUND  (MAX_CHANNEL-1) // Obere Grenze der Aktiven Kanalklassen (ist auch maximale Anzahl der Kanaele insgesammt)
#define MAX_ACTIVE_CHANNEL          ((MAX_CHANNEL-1)-ACTIVE_CHANNEL_LOWER_BOUND)  // Maximalanzahl der Aktiven Kanalklassen im oberen Nummernkreis

// Verwalten der Kommunikationskanaele
class CAEChannelArray
{
public:
	CAEChannelArray();
	virtual ~CAEChannelArray();

	// Kanalarray ueber Indizierungsoperator verwalten
	CAEChannel* operator[](short channelID) const
		{ return m_channels[channelID]; }
	CAEChannel*& operator[](short channelID)
		{ return (CAEChannel*&)m_channels[channelID]; }

	inline void Set(int idx, CAEChannel* channel)
	{
		m_channels[idx] = channel;
	}
protected:
	CAEChannel *m_channels[MAX_CHANNEL];
};

#endif // !defined(AFX_AE3CHANNELARRAY_H__E3C45889_4BC1_4E74_9A5C_284BD5DD180D__INCLUDED_)

