#ifndef _PZEMAIV_H_
#define _PZEMAIV_H_

typedef struct {

	unsigned char version; // Versionserkennung
	unsigned char cnt;     // Anzahl vorhandener Zeichensaetze
	unsigned char temp[2]; // Reserve
	unsigned int ptrFontArray; // Zeiger auf den 1. vorhandenen Zeichensatz

} FONTNODE;

 

typedef struct {

	unsigned char version; // Versionserkennung
	char name[32];         // Name des Zeichensatzes
	unsigned char type;    // 0 = System, 1 = User
	short bytesPerChar;    // Bytes pro Zeichen (gilt fr alle Zeichen)
	unsigned char linesPerChar; // Zeilen pro Zeichen (-"-)
	unsigned char temp[3]; // Reserve
	unsigned int crc;
	unsigned int size;   // Groesse in Byte des Zeichensatzes
	unsigned int ptrTable; // Zeiger auf Zeichentabelle
	unsigned int ptrCharacter; // Zeiger auf das 1. Zeichen

} FONT;

// Der Text wird, wenn der Blocktyp "Text" nicht unterstuetzt wird
// als Zeichensatz ausgegeben. Daher ist der Strukturaufbau der gleiche.
// Die Unterscheidung das es sich um einen Text handelt wird ueber den type = 2 gemacht.
typedef struct {

	unsigned char version; // Versionserkennung
	char name[32];         // Bezeichnung fuer Struktur
	unsigned char type;    // 0 = System, 1 = User, 2 = Text Default, 3 = Text User
	unsigned char temp[4]; // Unbenutzt
	unsigned short cnt;  // Maximale ID + 1, auch Anzahl Texte
	unsigned int crc;
	unsigned int size;   // Groesse in Byte der Textdaten
	unsigned int ptrIDTable; // Zeiger auf ID-Tabelle (sizeof(TEXT))
	unsigned int ptrTextdata; // Zeiger auf den 1sten Text (sizeof(TEXT) + maxID*sizeof(unsigned short))

} TEXTDATA;

typedef struct {

	unsigned char version;
	unsigned char cnt;
	unsigned char temp[2];
	unsigned int ptrGraficArray;

} GRAFICNODE;

 

typedef struct {

	unsigned char version;
	char name[32];
	unsigned char type; // 0 = Systemicon, 1 = Bitmap
	unsigned char temp[2];
	unsigned short width;
	unsigned short height;
	unsigned int crc;
	unsigned int ptrGrafic;

} GRAFIC;

typedef struct {

	unsigned char version;
	unsigned char cnt;
	unsigned char temp[2];
	unsigned int ptrTouchkeyArray;
} TOUCHKEYNODE;
/*
#define KEY_NO                                   (0)
#define KEY_DUMMY                                (255)
#define KEY_UNDEF                                (255)
#define KEY_SHIFT_ON                             (0x02)
#define KEY_SHIFT_OFF                            (0x03)
#define KEY_CLR                                  (8)
#define KEY_SWITCH                               (12)
#define KEY_CR                                   (13)
#define KEY_ESC                                  (27)
#define KEY_NUM_BLOCK                            (10)

#define KEY_QUOTE                                (34)

#define KEY_PERCENT                              (37)

#define KEY_BR_RD_LE                             (40)
#define KEY_BR_RD_RI                             (41)
#define KEY_ASTERISK                             (42)
#define KEY_PLUS                                 (43)
#define KEY_COMMA                                (44)
#define KEY_MINUS                                (45)
#define KEY_DOT                                  (46)
#define KEY_SLASH                                (47)
#define KEY_0                                    (48)
#define KEY_1                                    (49)
#define KEY_2                                    (50)
#define KEY_3                                    (51)
#define KEY_4                                    (52)
#define KEY_5                                    (53)
#define KEY_6                                    (54)
#define KEY_7                                    (55)
#define KEY_8                                    (56)
#define KEY_9                                    (57)
#define KEY_COLON                                (58)
#define KEY_SEMICOLON                            (59)
#define KEY_BR_SQ_LE                             (60)
#define KEY_EQUAL                                (61)
#define KEY_BR_SQ_RI                             (62)

#define KEY_A                                    (65)
#define KEY_B                                    (66)
#define KEY_C                                    (67)
#define KEY_D                                    (68)
#define KEY_E                                    (69)
#define KEY_F                                    (70)
#define KEY_G                                    (71)
#define KEY_H                                    (72)
#define KEY_I                                    (73)
#define KEY_J                                    (74)
#define KEY_K                                    (75)
#define KEY_L                                    (76)
#define KEY_M                                    (77)
#define KEY_N                                    (78)
#define KEY_O                                    (79)
#define KEY_P                                    (80)
#define KEY_Q                                    (81)
#define KEY_R                                    (82)
#define KEY_S                                    (83)
#define KEY_T                                    (84)
#define KEY_U                                    (85)
#define KEY_V                                    (86)
#define KEY_W                                    (87)
#define KEY_X                                    (88)
#define KEY_Y                                    (89)
#define KEY_Z                                    (90)

#define KEY_UNDERLINE                            (95)

#define KEY_F1                                   (112)//entspricht MS VK_F1 70h
#define KEY_F2                                   (113)
#define KEY_F3                                   (114)
#define KEY_F4                                   (115)
#define KEY_F5                                   (116)
#define KEY_F6                                   (117)
#define KEY_F7                                   (118)
#define KEY_F8                                   (119)
#define KEY_F9                                   (120)
#define KEY_F10                                  (121)
#define KEY_F11                                  (122)
#define KEY_F12                                  (123)
#define KEY_F13                                  (124)
#define KEY_F14                                  (125)
#define KEY_F15                                  (126)

#define KEY_SEL_1                                (128)
#define KEY_SEL_2                                (129)
#define KEY_SEL_3                                (130)
#define KEY_SEL_4                                (131)
#define KEY_SEL_5                                (132)
#define KEY_SEL_6                                (133)

#define KEY_UP                                   (144)
#define KEY_DOWN                                 (145)
#define KEY_LEFT                                 (146)
#define KEY_RIGHT                                (147)

#define KEY_M1                                   (160)
#define KEY_M2                                   (161)
#define KEY_M3                                   (162)
#define KEY_M4                                   (163)
// Umgendert am 30.07.2009
#define KEY_F1                                   (192)//112
#define KEY_F2                                   (193)//113
#define KEY_F3                                   (194)//114
#define KEY_F4                                   (195)//115
#define KEY_F5                                   (196)//116
#define KEY_F6                                   (197)//117
#define KEY_F7                                   (198)//118
#define KEY_F8                                   (199)//119
#define KEY_F9                                   (200)//120
#define KEY_F10                                  (201)//121
#define KEY_F11                                  (202)//122
#define KEY_F12                                  (203)//123

#define KEY_CHECK                                (239)
#define KEY_COM1                                 (240)
#define KEY_SERVICE                              (241)
#define KEY_MONITORING                           (242)
#define KEY_REDRAW                               (243)
#define KEY_MESSAGE                              (244)
#define KEY_EVENT                                (246)
#define KEY_BIOS_MENUE                           (247)
#define KEY_ERROR                                (248)
#define KEY_JUMP                                 (249)
#define KEY_MAIN_MENUE                           (250)
#define KEY_TRANSPONDER_MENUE                    (251)
#define KEY_MMC_MENUE                            (252)
#define KEY_ONOFF                                (254)
*/
#define TOUCHKEY_NONE        0
#define TOUCHKEY_CLR         8
#define TOUCHKEY_ENTER       13
#define TOUCHKEY_ESC         27
#define TOUCHKEY_DOT         46

#define TOUCHKEY_0           48
#define TOUCHKEY_1           49
#define TOUCHKEY_2           50
#define TOUCHKEY_3           51
#define TOUCHKEY_4           52
#define TOUCHKEY_5           53
#define TOUCHKEY_6           54
#define TOUCHKEY_7           55
#define TOUCHKEY_8           56
#define TOUCHKEY_9           57

#define TOUCHKEY_A           65
#define TOUCHKEY_B           66
#define TOUCHKEY_C           67
#define TOUCHKEY_D           68
#define TOUCHKEY_E           69
#define TOUCHKEY_F           70
#define TOUCHKEY_G           71
#define TOUCHKEY_H           72
#define TOUCHKEY_I           73
#define TOUCHKEY_J           74
#define TOUCHKEY_K           75
#define TOUCHKEY_L           76
#define TOUCHKEY_M           77
#define TOUCHKEY_N           78
#define TOUCHKEY_O           79
#define TOUCHKEY_P           80
#define TOUCHKEY_Q           81
#define TOUCHKEY_R           82
#define TOUCHKEY_S           83
#define TOUCHKEY_T           84
#define TOUCHKEY_U           85
#define TOUCHKEY_V           86
#define TOUCHKEY_W           87
#define TOUCHKEY_X           87
#define TOUCHKEY_Y           88
#define TOUCHKEY_Z           89


#define TOUCHKEY_F1         112
#define TOUCHKEY_F2         113
#define TOUCHKEY_F3         114
#define TOUCHKEY_F4         115
#define TOUCHKEY_F5         116
#define TOUCHKEY_F6         117
#define TOUCHKEY_F7         118
#define TOUCHKEY_F8         119
#define TOUCHKEY_F9         120
#define TOUCHKEY_F10        121
#define TOUCHKEY_F11        122
#define TOUCHKEY_F12        123
#define TOUCHKEY_F13        124
#define TOUCHKEY_F14        125
#define TOUCHKEY_F15        126
#define TOUCHKEY_UP         144
#define TOUCHKEY_DOWN       145
#define TOUCHKEY_LEFT       146
#define TOUCHKEY_RIGHT      147

#define TOUCHKEY_BIOS_MENUE 247
#define TOUCHKEY_ONOFF      254

// Die Tastenrahmen beziehen sich auf die obere linke Ecke des Touch der Aktiv Area
typedef struct {

	unsigned char flags;     // Zusatzflags zur Taste
	unsigned char key;       // Tastencode gem Tabelle in Firmwaredefinition (F1 -> 112)
	unsigned char left;      // Anfang Tastenrahmen linke Seite in mm.
	unsigned char top;       // Anfang Tastenrahmen obere Seite in mm.
	unsigned char right;     // Ende Tastenrahmen rechte Seite in mm.
	unsigned char bottom;    // Ende Tastenrahmen untere Seite in mm.
	unsigned char tmp[2];    // Reserve

} TOUCHKEY;


typedef struct {

	unsigned char version;
	unsigned char cnt;
	unsigned char temp[2];
	unsigned int ptrColorArray;
} DISPLAYCOLORNODE;

#define DISPLAYCOLOR_0                    0      // Standard, Standardwerte: Hintergrund
#define DISPLAYCOLOR_1                    1      // Standard, Standardwerte: Vordergrund
#define DISPLAYCOLOR_2                    2      // Kopfzeile System, Datum mit Uhrzeit: Schrift Hintergrund
#define DISPLAYCOLOR_3                    3      // Kopfzeile System, Datum mit Uhrzeit: Schrift
#define DISPLAYCOLOR_4                    4      // Kopfzeile System, Akkusymbol: Symbol Hintergrund
#define DISPLAYCOLOR_5                    5      // Kopfzeile System, Akkusymbol: Symbol
#define DISPLAYCOLOR_6                    6      // Kopfzeile System, Akkusymbol: Ladezustand: Gut
#define DISPLAYCOLOR_7                    7      // Kopfzeile System, Akkusymbol: Ladezustand: Niedrig
#define DISPLAYCOLOR_8                    8      // Kopfzeile System, Sonstige Symbole: Symbol Hintergrund
#define DISPLAYCOLOR_9                    9      // Kopfzeile System, Sonstige Symbole: Symbol
#define DISPLAYCOLOR_10                   10     // Menues, Kopfzeile 1 und 2: Symbol Hintergrund
#define DISPLAYCOLOR_11                   11     // Menues, Kopfzeile 1 und 2: Symbol
#define DISPLAYCOLOR_12                   12     // Menues, Kopfzeile 1 und 2: Schrift Hintergund
#define DISPLAYCOLOR_13                   13     // Menues, Kopfzeile 1 und 2: Schrift
#define DISPLAYCOLOR_14                   14     // Menues, Auswahlzeilen 1 bis 4: Symbol Hintergrund
#define DISPLAYCOLOR_15                   15     // Menues, Auswahlzeilen 1 bis 4: Symbol
#define DISPLAYCOLOR_16                   16     // Menues, Auswahlzeilen 1 bis 4: Schrift Hintergund
#define DISPLAYCOLOR_17                   17     // Menues, Auswahlzeilen 1 bis 4: Schrift
#define DISPLAYCOLOR_18                   18     // Menues, Fuzeile: Symbol Hintergrund
#define DISPLAYCOLOR_19                   19     // Menues, Fuzeile: Symbol
#define DISPLAYCOLOR_20                   20     // Menues, Fuzeile: Schrift Hintergund
#define DISPLAYCOLOR_21                   21     // Menues, Fuzeile: Schrift
#define DISPLAYCOLOR_22                   22     // Eingabe, Kopfzeile 1 und 2: Symbol Hintergrund
#define DISPLAYCOLOR_23                   23     // Eingabe, Kopfzeile 1 und 2: Symbol
#define DISPLAYCOLOR_24                   24     // Eingabe, Kopfzeile 1 und 2: Schrift Hintergund
#define DISPLAYCOLOR_25                   25     // Eingabe, Kopfzeile 1 und 2: Schrift
#define DISPLAYCOLOR_26                   26     // Eingabe, Auswahlzeilen 1 bis 4: Symbol Hintergrund
#define DISPLAYCOLOR_27                   27     // Eingabe, Auswahlzeilen 1 bis 4: Symbol
#define DISPLAYCOLOR_28                   28     // Eingabe, Auswahlzeilen 1 bis 4: Schrift Hintergund
#define DISPLAYCOLOR_29                   29     // Eingabe, Auswahlzeilen 1 bis 4: Schrift
#define DISPLAYCOLOR_30                   30     // Eingabe, Fuzeile: Symbol Hintergrund
#define DISPLAYCOLOR_31                   31     // Eingabe, Fuzeile: Symbol
#define DISPLAYCOLOR_32                   32     // Eingabe, Fuzeile: Schrift Hintergund
#define DISPLAYCOLOR_33                   33     // Eingabe, Fuzeile: Schrift
#define DISPLAYCOLOR_34                   34     // Bios, Kopfzeile 1 und 2: Symbol Hintergrund
#define DISPLAYCOLOR_35                   35     // Bios, Kopfzeile 1 und 2: Symbol
#define DISPLAYCOLOR_36                   36     // Bios, Kopfzeile 1 und 2: Schrift Hintergund
#define DISPLAYCOLOR_37                   37     // Bios, Kopfzeile 1 und 2: Schrift
#define DISPLAYCOLOR_38                   38     // Bios, Auswahlzeilen 1 bis 4: Symbol Hintergrund
#define DISPLAYCOLOR_39                   39     // Bios, Auswahlzeilen 1 bis 4: Symbol
#define DISPLAYCOLOR_40                   40     // Bios, Auswahlzeilen 1 bis 4: Schrift Hintergund
#define DISPLAYCOLOR_41                   41     // Bios, Auswahlzeilen 1 bis 4: Schrift
#define DISPLAYCOLOR_42                   42     // Bios, Fuzeile: Symbol Hintergrund
#define DISPLAYCOLOR_43                   43     // Bios, Fuzeile: Symbol
#define DISPLAYCOLOR_44                   44     // Bios, Fuzeile: Schrift Hintergund
#define DISPLAYCOLOR_45                   45     // Bios, Fuzeile: Schrift
#define DISPLAYCOLOR_46                   46     // Sonstiges, Systemstart / Systemstopp: Symbole und Schrift Hintergrund
#define DISPLAYCOLOR_47                   47     // Sonstiges, Systemstart / Systemstopp: Symbole und Schrift
#define DISPLAYCOLOR_48                   48     // Sonstiges, Fortschrittsanzeige: Symbole und Schrift Hintergrund
#define DISPLAYCOLOR_49                   49     // Sonstiges, Fortschrittsanzeige: Symbole und Schrift
#define DISPLAYCOLOR_COUNT                50     // Gesamtanzahl Farbdefinitionen

typedef struct {

	unsigned char id;        // Farbcode der angibt was die Farbe definiert.
	unsigned char r;         // Rotanteil der Gesamtfarbe.
	unsigned char g;         // Gruenanteil der Gesamtfarbe.
	unsigned char b;         // Blauanteil der Gesamtfarbe.

} DISPLAYCOLOR;

#endif
